<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 14/11/2014
 * Time: 16:43
 */

namespace Folha\Logic\ValesBeneficios\IntegracaoEletronicaVT;


class LeitorOtimo extends  Leitor
{
    protected $formatosAceitos = 'HTML|HTM|XML';

    /**
     * Abre o arquivo que contém a informação de saldo disponível do vale-transporte.
     * @param String $caminho
     * @return \SimpleXMLElement
     */
    protected function abrirArquivo($caminho)
    {

        $conteudo = file_get_contents($caminho);
        $conteudo = html_entity_decode(preg_replace("/&nbsp;/",'', $conteudo));

        $doc = new \DOMDocument();
        $doc->loadHTML($conteudo);
        $infos = $doc->getElementsByTagName('td');

        return $infos;


    }


    /**
     * Cria um Array contendo Arrays no formato:
     * [
     *     NUMERO_CARTAO : '',
     *     SALDO_CARTAO : ''
     * ]
     * @param \PHPExcel $infos
     * @return Array
     * @throws ExcessaoIntegracaoVT
     * @throws \Exception
     */
    protected function preparaInfo( $infos)
    {
        $infoFinal = array();
        $aux = array();
        $cont_1 = 0;
        $cont_2 = 1;

        foreach($infos as $info){
            if($cont_1>6){
                $cont_2++;
                switch($cont_1){
//                    case($cont_1%5==2):{
//                        $aux['MATRICULA'] = $info->nodeValue;
//                        break;
//                    }
//                    case($cont_1%5==3):{
//                        $aux['NOME'] = $info->nodeValue;
//                        break;
//                    }
//                    case($cont_1%5==4):{
//                        $aux['TIPO'] = $info->nodeValue;
//                        break;
//                    }
                    case($cont_1%5==0):{
                        $aux['NUMERO_CARTAO'] = $info->nodeValue;
                        break;
                    }
                    case($cont_1%5==1):{
                        $aux['SALDO_CARTAO'] = $info->nodeValue;
                        break;
                    }
                }
                if($cont_2%5 == 2){
                    if(!empty($aux))
                        $infoFinal[] = $aux;
                }
            }
            $cont_1++;
        }

        return $infoFinal;
    }


}