<?php
namespace Suprimentos\Logic\Compra;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;
use Suprimentos\Entities\Coletapr;
use Suprimentos\Entities\Itemcole;
use Suprimentos\Entities\Pedcolgeral;
use Suprimentos\Entities\Pedcoleta;
use Suprimentos\Entities\Fornepedcol;

class RegistraColetaGeral{


    //Insere Nova Coleta de preços diretamente na tabela COLETAPR
    public static function insColetaPr($nrorg,$cdfilisoli, $nrcolepreco, $nrsemainic, $nrsemafinal, $dtini, $dtfin, $cdopersoli, $dtcoleprec, $iddismontlis, $cdoperincl, $dsobscotprec, $idsitucoleta, $nrcompra)
    {
        try{
            $coleta = new Coletapr();
            $coleta->setCdfilial($cdfilisoli);
            $coleta->setNrorg($nrorg);
            $coleta->setNrcolepreco($nrcolepreco);
            $coleta->setNrsemainic($nrsemainic);
            $coleta->setNrsemafinal($nrsemafinal);
            $coleta->setDtinivalcol(DateUtil::getDataDeString($dtini));
            $coleta->setDtfinvalcol(DateUtil::getDataDeString($dtfin));
            $coleta->setCdoperador($cdopersoli);
            $coleta->setCdoperincl($cdoperincl);
            $coleta->setDtcoleprec($dtcoleprec);
            $coleta->setIddismontlis($iddismontlis);
            $coleta->setDsobscotprec($dsobscotprec);
            $coleta->setIdsitucoleta($idsitucoleta);
            $coleta->setNrcompra($nrcompra);
            $coleta->persist();
            Registry::getEntityManager()->flush();
            return $coleta;

        }catch(\Exception $e){
            throw $e;
        }
    }

    public static function insPedcolGeral($nrorg, $cdfilial, $nrpedidocol, $dtpedcolgeral, $dtinipergeral, $dtfinpergeral, $idpedcolcons, $cdoperador, $cdoperlanc, $dtexpirapedcol)
    {
        try {
            $pedcolgeral = new Pedcolgeral();
            $pedcolgeral->setNrorg($nrorg);
            $pedcolgeral->setCdfilial($cdfilial);
            $pedcolgeral->setNrpedidocol($nrpedidocol);
            $pedcolgeral->setDtpedcolgeral($dtpedcolgeral);
            $pedcolgeral->setDtinipergeral($dtinipergeral);
            $pedcolgeral->setDtfinpergeral($dtfinpergeral);
            $pedcolgeral->setIdpedcolcons($idpedcolcons);
            $pedcolgeral->setCdoperador($cdoperador);
            $pedcolgeral->setCdoperlanc($cdoperlanc);
            $pedcolgeral->setDtexpirapedcol($dtexpirapedcol);
            $pedcolgeral->persist();
            Registry::getEntityManager()->flush();
            return $pedcolgeral;


        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insPedcoleta($nrorg, $cdfilial, $nrpedcoleta, $cdforneced, $dtpedcoleta, $cdoperador, $dtinipercot, $dtfinpercot, $cdregiao, $cdleilao, $nrpedidocol)
    {
        try {
            $pedcoleta = new Pedcoleta();
            $pedcoleta->setNrorg($nrorg);
            $pedcoleta->setCdfilial($cdfilial);
            $pedcoleta->setNrpedcoleta($nrpedcoleta);
            $pedcoleta->setCdforneced($cdforneced);
            $pedcoleta->setDtpedcoleta($dtpedcoleta);
            $pedcoleta->setCdoperador($cdoperador);
            $pedcoleta->setDtinipercot($dtinipercot);
            $pedcoleta->setDtfinpercot($dtfinpercot);
            $pedcoleta->setCdregiao($cdregiao);
            $pedcoleta->setCdleilao($cdleilao);
            $pedcoleta->setNrpedidocol($nrpedidocol);
            $pedcoleta->persist();
            Registry::getEntityManager()->flush();
            return $pedcoleta;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insFornepedcol($nrorg, $cdfilial, $nrpedidocol, $cdforneced)
    {
        try {
            $fornepedcol = new Fornepedcol();
            $fornepedcol->setNrorg($nrorg);
            $fornepedcol->setCdfilial($cdfilial);
            $fornepedcol->setNrpedidocol($nrpedidocol);
            $fornepedcol->setCdforneced($cdforneced);
            $fornepedcol->persist();
            Registry::getEntityManager()->flush();
            return $fornepedcol;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insRegiaoPedCol($nrorg, $cdfilial, $nrpedidocol, $cdregiao)
    {
        try {
            $regiaopedcol = new Regiaopedcol();
            $regiaopedcol->setNrorg($nrorg);
            $regiaopedcol->setCdfilial($cdfilial);
            $regiaopedcol->setNrpedidocol($nrpedidocol);
            $regiaopedcol->setCdregiao($cdregiao);
            $regiaopedcol->persist();
            Registry::getEntityManager()->flush();
            return $regiaopedcol;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insItemPed($nrorg, $cdfilial, $cdforneced, $nrpedcoleta, $cdregiao, $cdproduto, $cdmarca, $qtprodpedcol, $idseleleilao, $vrantitpedcol, $desconto)
    {
        try {
            $itempedcol = new Itempedcol();
            $itempedcol->setNrorg($nrorg);
            $itempedcol->setCdfilial($cdfilial);
            $itempedcol->setCdforneced($cdforneced);
            $itempedcol->setNrpedcoleta($nrpedcoleta);
            $itempedcol->setCdregiao($cdregiao);
            $itempedcol->setCdproduto($cdproduto);
            $itempedcol->setCdmarca($cdmarca);
            $itempedcol->setQtprodpedcol($qtprodpedcol);
            $itempedcol->setIdseleleilao($idseleleilao);
            $itempedcol->setVrantitpedcol($vrantitpedcol);
            $itempedcol->setDesconto($desconto);
            $itempedcol->persist();
            Registry::getEntityManager()->flush();
            return $itempedcol;

        } catch (\Exception $e) {
            throw $e;
        }
    }


    public static function insPrMarcPedCol($nrorg, $cdfilial, $nrpedidocol, $cdproduto, $cdmarca, $vrultprecprmarc)
    {
        try {
            $prmarcpedcol = new PrMarcPedCol();
            $prmarcpedcol->setNrorg($nrorg);
            $prmarcpedcol->setCdfilial($cdfilial);
            $prmarcpedcol->setNrpedidocol($nrpedidocol);
            $prmarcpedcol->setCdproduto($cdproduto);
            $prmarcpedcol->setCdmarca($cdmarca);
            $prmarcpedcol->setVrultprecprmarc($vrultprecprmarc);
            $prmarcpedcol->persist();
            Registry::getEntityManager()->flush();
            return $prmarcpedcol;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updatePrecoXls($nrcolepreco,$cdforneced,$cdregiao,$cdfilicentcmp,$cdproduto,$cdmarca,$qtforn,$vratual){
        try{
            $forcompra = itemcole::findOneByNrcoleprecoAndCdfornecedAndCdregiaoAndCdfilialAndCdprodutoAndCdmarca($nrcolepreco,$cdforneced,$cdregiao,$cdfilicentcmp,$cdproduto,$cdmarca);
            if($forcompra){
                $forcompra->setQtacmpitmcol ($qtforn);
                $forcompra->setVrprecuniitm($vratual);
                $forcompra->setVrorig($vratual);
                $forcompra->persist();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
    public static function updatePrecoManual($nrcolepreco,$cdforneced,$cdregiao,$cdfilicentcmp,$cdproduto,$cdmarca,$vrnovo,$qtforn){
        try{
            $forcompra = itemcole::findOneByNrcoleprecoAndCdfornecedAndCdregiaoAndCdfilialAndCdprodutoAndCdmarca($nrcolepreco,$cdforneced,$cdregiao,$cdfilicentcmp,$cdproduto,$cdmarca);
            if($forcompra){
                $forcompra->setVrprecuniitm($vrnovo);
                $forcompra->setQtacmpitmcol ($qtforn);
                $forcompra->persist();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
}